;copywrite 2001 by Samuel Stearley


;ti89

 ifnd ti89
ti92plus
 endc

	include	"os.h"

 ifd ti89
	xdef		_ti89
 endc

 ifd ti92plus
	xdef		_ti92plus
 endc


	xdef		_nostub


;---First thing to do is to find the pointer to the flag that tells me if
;---the cursor is in the entry line.  And then put it into code.


	movem.l	d3-d7/a2-a6,-(a7)
	move.l	a7,d7				;save stack pointer
	move.l	200,a6			;pointer to the jump table
	move.l	1080(a6),a0			;get pointer to the code of home execute call
	move.l	708(a6),d0			;get pointer to te_select- will search
							;  for this value in the code of the home execute
							;  call
search_loop:
	addq.l	#2,a0				;code is alligned on words
	cmp.l		(a0),d0			;is it the place to jsr too?
	bne		search_loop
	move.w	-4(a0),d0			;now got pointer to the tios entyline text edit
							;  structure.
	add.w		#32,d0			;point it to the flag

	lea		btst_opcode+4(pc),a0	;point to adress operand
	move.w	d0,(a0)			;move it into the ram

;---The Second thing to do is to get the pointer to the first window
;---and install it into my code

	move.l	3324(a6),a0		;get cmd_disphome
	jsr		(a0)

	move.l	(a6),a0		;get pointer to the first window pointer
	move.l	(a0),a0		;now get a pointer to the first window
	addq.w	#1,a0			;so it points to the byte with the active flag
	lea		tst_opcode+2(pc),a1;get pointer to operand part
	move.w	a0,(a1)		;move it into my code

;---SO NOW INSTALL MY EVENT HOOK----

	move.l	2700(a6),a5
	lea		old_event(pc),a1
	move.l	(a5),(a1)
	move.l	#END_OF_HOOK-BEGINNING_OF_HOOK,d3
	move.l	d3,-(a7)
	move.l	584(a6),a0
	jsr		(a0)
	pea		error_message
	tst.w		d0
	beq		memory_error
	move.w	d0,-(a7)
	move.l	600(a6),a0			;get dereference call
	jsr		(a0)
	move.l	a0,a1
	add.l		#$40010,a0
	move.l	a0,(a5)
	subq.l	#1,d3
	lea		BEGINNING_OF_HOOK(pc),a0
copy_loop:
	move.b	(a0)+,(a1)+
	dbra		d3,copy_loop
	pea		message(pc)
memory_error:
	move.l	920(a6),a0			;help displag call
	jsr		(a0)

;---Restore Registers and exit the installation-----


final:
	move.l	d7,a7
	movem.l	(a7)+,d3-d7/a2-a6
	rts

;------------------------------------------------------
;AND NOW THE STRINGS AND DATA OF THE INSTALLATION PART
;------------------------------------------------------

message:		dc.b		"Best View by Samuel Stearley (C) 2000",0
error_message:	dc.b		"Error: Not enough Memory",0

	EVEN	


;----------------------------------------------
;AND NOW FOR THE CODE OF THE HOOK
;----------------------------------------------

BEGINNING_OF_HOOK:
		dc.b	"evHkBestView"	;signature and name
old_event:	dc.l	0			;space for the old event



;----First check the event type and if the home
;----application is active.

	movem.l	d0-d7/a0-a6,-(a7)
	move.l	64(a7),a2			;get pointer to the event structure
	cmp.w		#$705,(a2)			;are applications changing, if so then reset the
							;  variable
	beq		restart_variables

tst_opcode:
	tst.b		$1234				;garbage for the pointer to the first window
	bpl		pass_it_on			;if it is not on the home screen then I do nothing
btst_opcode:
	btst.b	#1,$1234			;garbage for the pointer to the cursor on the entry
							;  line flag.
	bne		pass_it_on

;---note that pressing backspace will result in two events, a keypress event
;---And command del.  So I only check for command Del, which is also caused
;---by choosing del from the f1 menu.


	move.w	#263,d3			;clear keypress
	cmp.w		#$725,(a2)			;is it CM_DEL
	beq		DeletionSoD3IsClearKeyPress

	cmp.w		#$710,(a2)			;is it command keypress?
	bne		pass_it_on

;----Get the number of fifo nodes and the key-------


	move.w	10(a2),d3			;get the key press

DeletionSoD3IsClearKeyPress:
	move.l	200,a6			;get ptr to the jump table
	move.l	2292(a6),a0			;get count fifo node call
	jsr		(a0)				;count the fifo nodes
	move.w	d0,d7
	lsl.w		#1,d7				;double it
	subq.w	#1,d7				;decrease it

	lea		position(pc),a3		;place in the entry stack


;----Start checking the keys-------

	cmp.w		#264,d3			;is it escape?
	beq		restart_variables

 ifd ti89
	cmp.w		#16721,d3			;is it diamond + up?
 endc

 ifd ti92plus
	cmp.w		#8530,d3			;is it diamond + up?
 endc

	bne		not_diamond_up

	move.w	d7,(a3)
	bra		pass_it_on

not_diamond_up:


 ifd ti89
	cmp.w		#16724,d3			;is it diamond + down?
 endc

 ifd ti92plus
	cmp.w		#8536,d3			;is it diamond +down?
 endc

	beq		restart_variables
	cmp.w		#13,d3			;is it enter?
	beq		restart_variables		;then done
	cmp.w		#263,d3			;is it clear?
	bne		no_deletion

;----Code to account for deletion------

account_for_deletion:

	moveq.l	#-2,d6			;the mask	%1111111111111110
	and.w		d6,(a3)			;subtract 1 if odd - leave alone if even
	and.w		d6,d7				;do the same to the number of fifo nodes
	cmp.w		(a3),d7			;if they are equal then it was the very top fifo
							;  node that was deleted
	bne		pass_it_on
	subq.w	#1,(a3)			;decrease it again if it was the top
	bcc		pass_it_on
	clr.w		(a3)
	bra		pass_it_on

no_deletion:


;----Now for the up and down arrows-------


 ifd ti89

	cmp.w		#337,d3			;is it up?
	beq		increment_position
	cmp.w		#340,d3			;is it down?
	bne		do_not_decrement_position

 endc

 ifd ti92plus

	cmp.w		#338,d3			;is it up?
	beq		increment_position
	cmp.w		#344,d3			;is it down?
	bne		do_not_decrement_position

 endc

;----Code to decrement the position---

	subq.w	#1,(a3)
	bcc		pass_it_on
	clr.w		(a3)
	bra		pass_it_on

;----Code to increment the position---

increment_position:

	cmp.w		(a3),d7
	beq		pass_it_on			;if it is at the limit then do nothing
	addq.w	#1,(a3)
	bra		pass_it_on

do_not_decrement_position:

	cmp.w		#269,d3			;is it the f2?
	bne		pass_it_on

;--------------------------------------------
;
;IF IT WAS F2 THEN DISPLAY IT!!!!
;
;--------------------------------------------


	movem.l	a2,-(a7)			;save the pointer to the event
	move.l	a7,d3				;SAVE THE STACK POINTER
	move.w	#$700,(a2)			;make it command idle
	move.l	1060(a6),a5			;get pointer to top estack
	move.l	(a5),d7			;save top estack
	lea		-250(a7),a7			;allocate memory for the window
	move.l	a7,a4				;a4 is pointer to the window



;----Get the handle of what to display-----

	clr.w		d5				;parse flags
	move.l	2308(a6),a0			;get the "get answer call"
	move.w	(a3),d0			;get the position
	lsr.w		#1,d0				;divide by two and test for odd or even
	bcc		even_so_answer
	move.l	2312(a6),a0	
	moveq		#1,d5
even_so_answer:
	addq.w	#1,d0
	move.w	d0,-(a7)
	jsr		(a0)				;get the handle
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
	move.w		d5,-(a7)
	move.w		d0,-(a7)
	beq			window_was_not_made
	move.l		300(a6),a0
	jsr			(a0)
	move.l		a0,a2
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
	move.w		#$300,-(a7)
	pea			rect(Pc)
	move.l		a4,-(a7)
	move.l		120(a6),a0
	jsr			(a0)
	tst.b			d0
	beq			window_was_not_made
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
	pea			top_half(pc)
	pea			bottom_half(pc)
	pea			width(pc)
	push.l		a2
	move.l		308(a6),a0
	jsr			(a0)
	moveq			#0,d5				;initial X is zero
	move.w		d0,d6				;Get the Y of the thing to be displayed
	move.w		d6,d4				;this copy will not be altered
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
;EVERYTHING BEFORE THIS POINT WAS JUST SET UP.  THE FOLLOWING CODE IS THE MAIN LOOP THAT
;TAKES KEYPRESSES AND SCROLLS THE ANSWER AND CLEARS THE SCREEN BETWEEN THE SCROLLING.
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
REDRAW_THE_SCREEN:
	move.l		a4,-(a7)			;window that needs to be cleared
	move.l		48(a6),a0
	jsr			(a0)
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
	move.w		d6,-(a7)			;push the y
	move.w		d5,-(a7)			;push the x
	move.l		a4,-(a7)			;the window
	move.l		a2,-(a7)			;the result of the parse 2d
	move.l		304(a6),a0			;print 2d call
	jsr			(a0)
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
	lea			16(a7),a7			;in a loop so stack needs to be reset
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
get_another_key_press:

	clr.l			-(a7)
	clr.w			-(a7)
	move.l		1528(a6),a0			;idle call
	jsr			(a0)
	addq.l		#6,a7

	cmp.w			#264,d0
	beq			quit

 ifd ti89
	cmp.w			#344,d0
	beq			scroll_right
	cmp.w			#338,d0
	beq			scroll_left
	cmp.w			#340,d0
	beq			scroll_down
	cmp.w			#337,d0
	beq			scroll_up

;----Now for diamond char + arrows

	cmp.w			#16728,d0
	beq			scroll_rightD
	cmp.w			#16722,d0
	beq			scroll_leftD
	cmp.w			#16724,d0
	beq			scroll_downD
	cmp.w			#16721,d0
	beq			scroll_upD

 endc

 ifd ti92plus
	cmp.w			#340,d0
	beq			scroll_right
	cmp.w			#337,d0
	beq			scroll_left
	cmp.w			#344,d0
	beq			scroll_down
	cmp.w			#338,d0
	beq			scroll_up

;------now for the diamond + arrows---

	cmp.w			#8532,d0
	beq			scroll_rightD
	cmp.w			#8529,d0
	beq			scroll_leftD
	cmp.w			#8536,d0
	beq			scroll_downD
	cmp.w			#8530,d0
	beq			scroll_upD

 endc

	bra			get_another_key_press
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
scroll_right:
	move.w		d5,d1				;copy of x
	add.w			width(pc),d1		;add the width to the x

 ifd ti89
	cmp.w			#160,d1
 endc

 ifd ti92plus
	cmp.w			#240,d1
 endc
	bcs			get_another_key_press
	add.w			#-40,d5
	bra			REDRAW_THE_SCREEN
scroll_left:
	tst.w			d5
	bge			get_another_key_press
	add.w			#40,d5
	bra			REDRAW_THE_SCREEN
scroll_up:
	cmp.w			d4,d6
	bge			get_another_key_press
	add.w			#28,d6
	bra			REDRAW_THE_SCREEN
scroll_down:
	move.w		d6,d0
	add.w			bottom_half(pc),d0

 ifd ti89
	cmp.w			#93,d0
 endc

 ifd ti92plus
	cmp.w			#121,d0
 endc
	bcs			get_another_key_press
	add.w			#-28,d6
	bra			REDRAW_THE_SCREEN


;----DIAMOND + ARROWS--------------

scroll_rightD:
	move.w		d5,d1				;copy of x
	add.w			width(pc),d1		;add the width to the x

 ifd ti89
	cmp.w			#160,d1
 endc

 ifd ti92plus
	cmp.w			#240,d1
 endc
	bcs			get_another_key_press
	sub.w			rect+4(pc),d5
	bra			REDRAW_THE_SCREEN
scroll_leftD:
	tst.w			d5
	bge			get_another_key_press
	add.w			rect+4(pc),d5
	bra			REDRAW_THE_SCREEN
scroll_upD:
	cmp.w			d4,d6
	bge			get_another_key_press
	add.w			rect+6(pc),d6
	bra			REDRAW_THE_SCREEN
scroll_downD:
	move.w		d6,d0
	add.w			bottom_half(pc),d0

 ifd ti89
	cmp.w			#93,d0
 endc

 ifd ti92plus
	cmp.w			#121,d0
 endc
	bcs			get_another_key_press
	sub.w			rect+6(pc),d6
	bra			REDRAW_THE_SCREEN


;-----NOW TO EXIT-----

quit:
	move.l		a4,-(a7)
	move.l		44(a6),a0			;window close call
	jsr			(a0)				;close it

window_was_not_made:

	move.l		d3,a7
	move.l		d7,(a5)			;reset the expression stack
	move.l		(a7)+,a2
	bra			pass_it_on

;----If the history is left then the variable is restarted----

restart_variables:
	lea		variables(pc),a0
	clr.w		(a0)

;----Now for some code to pass the event on to tios or the next hook----

pass_it_on:
	movem.l	(a7)+,d0-d7/a0-a6		;get the saved registers
	move.l	old_event(pc),d0		;get the nex event hook in line
	beq		no_old_hook
	move.l	d0,-(a7)
no_old_hook:
	rts

;-----------------------------------------
;AND NOW FOR THE VARIABLES OF MY HOOK
;-----------------------------------------

variables:
position:		dc.w		0

 ifd ti89
rect			dc.w		0,0,160,92
 endc

 ifd ti92plus
rect:			dc.w		0,0,240,120
 endc

width		dc.w		0
bottom_half	dc.w		0
top_half	dc.w		0



END_OF_HOOK:


	end		

